// TODO consider renaming this to "searchUtility.js"

import { searchBarTimeout, searchSection, lastQuery } from "./main.js"
import Dataset from "./dataset.js"

export async function fetchQuery(fetchString, clearResults) {
    clearTimeout(searchBarTimeout);
    const response = await fetch(fetchString);
    const data = await response.json();

    parseContent(data.content, clearResults);
    lastQuery.totalPages = data.page.totalPages;
    if (clearResults) {
        lastQuery.currentPage = 0;
    }
}

function parseContent(content, clearResults) {
    const nothingFoundElement = searchSection.querySelector("#nothing-found");

    if (content.length === 0) {
        nothingFoundElement.classList.remove("hidden");
        searchSection.querySelector(".datasets").classList.add("hidden");
    } else {
        nothingFoundElement.classList.add("hidden");

        const datasets = content.map(dataset => Dataset.get(dataset.id) ?? new Dataset(dataset));
        searchSection.querySelector(".datasets").classList.remove("hidden");
        if (clearResults) {
            Array.from(searchSection.querySelectorAll(".datasets .dataset")).forEach(e => e.remove());
        }

        for (const dataset of datasets) {
            searchSection.querySelector(".datasets")
                .appendChild(dataset.createDatasetHTMLElement());
        }
    }
}
