package de.uni_passau.fim.PADAS.group3.DataDash.category;

import static org.mockito.Mockito.*;
import static org.junit.jupiter.api.Assertions.*;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;

public class CategoryServiceTest {

    @Mock
    private CategoryRepository categoryRepository;

    @InjectMocks
    private CategoryService categoryService;

    @BeforeEach
    public void setUp() {
        MockitoAnnotations.openMocks(this);
    }

    @Test
    public void testAddCategory() {
        CategoryDto categoryDto = new CategoryDto("Test Category", UUID.randomUUID());
        categoryService.addCategory(categoryDto);

        verify(categoryRepository, times(1)).save(any(Category.class));
    }

    @Test
    public void testGetAllCategories() {
        when(categoryRepository.findAll()).thenReturn(Arrays.asList(new Category("Category 1"), new Category("Category 2")));

        List<CategoryDto> categories = categoryService.getAllCategories();

        assertNotNull(categories);
        assertEquals(2, categories.size());
    }

    @Test
    public void testGetCategoryByIdFound() {
        UUID id = UUID.randomUUID();
        Category category = new Category("Test Category");
        when(categoryRepository.getCategoryById(id)).thenReturn(category);

        CategoryDto result = categoryService.getCategoryById(id);

        assertNotNull(result);
        assertEquals("Test Category", result.getName());
    }

    @Test
    public void testGetCategoryByIdNotFound() {
        UUID id = UUID.randomUUID();
        when(categoryRepository.getCategoryById(id)).thenReturn(null);

        CategoryDto result = categoryService.getCategoryById(id);

        assertNull(result);
    }
}